# nblib2
Library for NBdomain

## Functions

<dl>
<dt><a href="#setOpay">setOpay(opay)</a></dt>
<dd><p>Set opay object to be used in webpage.</p>
</dd>
<dt><a href="#sha256">sha256(string)</a> ⇒ <code>string</code></dt>
<dd></dd>
<dt><a href="#getDomain">getDomain(root)</a> ⇒ <code>object</code></dt>
<dd></dd>
<dt><a href="#setPrivateKey">setPrivateKey(privateKey)</a></dt>
<dd></dd>
<dt><a href="#makePublic">makePublic(domain)</a> ⇒ <code>json</code></dt>
<dd><p>Make a domain as public, so everyone can write to it. inreversible.</p>
</dd>
<dt><a href="#writePublicDomain">writePublicDomain(option)</a> ⇒ <code>json</code></dt>
<dd><p>Write contents to a public domain</p>
</dd>
<dt><a href="#updateKey2">updateKey2(option)</a> ⇒ <code>json</code></dt>
<dd></dd>
<dt><a href="#verifySig">verifySig(data_hash, strSig)</a> ⇒ <code>bool</code></dt>
<dd></dd>
<dt><a href="#buy">buy(option)</a> ⇒ <code>json</code></dt>
<dd></dd>
<dt><a href="#getNodeInfo">getNodeInfo()</a> ⇒ <code>json</code></dt>
<dd></dd>
<dt><a href="#queryDomain">queryDomain(domain, full)</a> ⇒ <code>json</code></dt>
<dd></dd>
<dt><a href="#domainFromAddress">domainFromAddress(address)</a> ⇒ <code>json</code></dt>
<dd></dd>
</dl>

<a name="setOpay"></a>

## setOpay(opay)
Set opay object to be used in webpage.

**Kind**: global function  

| Param | Type | Description |
| --- | --- | --- |
| opay | <code>object</code> | opay or opay2 object |

<a name="sha256"></a>

## sha256(string) ⇒ <code>string</code>
**Kind**: global function  
**Returns**: <code>string</code> - hashed string  

| Param | Type | Description |
| --- | --- | --- |
| string | <code>string</code> | to hash |

<a name="getDomain"></a>

## getDomain(root) ⇒ <code>object</code>
**Kind**: global function  
**Returns**: <code>object</code> - domain object  

| Param | Type | Description |
| --- | --- | --- |
| root | <code>string</code> | domain name |

<a name="setPrivateKey"></a>

## setPrivateKey(privateKey)
**Kind**: global function  

| Param | Type | Description |
| --- | --- | --- |
| privateKey | <code>string</code> | to be used with nodeJS app |

<a name="makePublic"></a>

## makePublic(domain) ⇒ <code>json</code>
Make a domain as public, so everyone can write to it. inreversible.

**Kind**: global function  
**Returns**: <code>json</code> - result  

| Param | Type | Description |
| --- | --- | --- |
| domain | <code>string</code> | to set as public |

<a name="writePublicDomain"></a>

## writePublicDomain(option) ⇒ <code>json</code>
Write contents to a public domain

**Kind**: global function  
**Returns**: <code>json</code> - result of the update  

| Param | Type | Description |
| --- | --- | --- |
| option | <code>object</code> | option of the update |
| option.kv | <code>object</code> | key/value pairs. eg: for key {abc:{abc:"234"}} or {abc:{def:100}} or for keys ab and cd {ab:100,cd:200} |
| option.isUser | <code>Boolean</code> | indicate it's for key.domain.tld or key@domain.tld |
| option.pay | <code>Array.&lt;object&gt;</code> | object array. eg: [{address:"dfdaf"},value:1000}]. some blockchain, like ar, only supports one receiver per tx |

<a name="updateKey2"></a>

## updateKey2(option) ⇒ <code>json</code>
**Kind**: global function  
**Returns**: <code>json</code> - result of the update  

| Param | Type | Description |
| --- | --- | --- |
| option | <code>object</code> | option of the update |
| option.kv | <code>object</code> | key/value pairs. eg: for key {abc:{abc:"234"}} or {abc:{def:100}} or for keys ab and cd {ab:100,cd:200} |
| option.tags | <code>string</code> | string. eg: for key {abc:{abc:"234"}} or {abc:{def:100}} or for keys ab and cd {ab:100,cd:200} |
| option.isUser | <code>Boolean</code> | indicate it's for key.domain.tld or key@domain.tld |
| option.pay | <code>Array.&lt;object&gt;</code> | object array. eg: [{address:"dfdaf"},value:1000}]. some blockchain, like ar, only supports one receiver per tx |

<a name="verifySig"></a>

## verifySig(data_hash, strSig) ⇒ <code>bool</code>
**Kind**: global function  
**Returns**: <code>bool</code> - result of verify  

| Param | Type | Description |
| --- | --- | --- |
| data_hash | <code>string</code> | hasded string of data |
| strSig | <code>string</code> | signature |

<a name="buy"></a>

## buy(option) ⇒ <code>json</code>
**Kind**: global function  
**Returns**: <code>json</code> - result  

| Param | Type | Description |
| --- | --- | --- |
| option | <code>object</code> | - |
| option.domain | <code>domain</code> | domain to buy |

<a name="getNodeInfo"></a>

## getNodeInfo() ⇒ <code>json</code>
**Kind**: global function  
**Returns**: <code>json</code> - nodeInfo from node  
<a name="queryDomain"></a>

## queryDomain(domain, full) ⇒ <code>json</code>
**Kind**: global function  

| Param | Type | Default | Description |
| --- | --- | --- | --- |
| domain | <code>string</code> |  | one or more domains, separated by ',' .eg "test.b" "test.b,www.abc.b" "aaa.test886.test/all,aaa.test886.test/1" |
| full | <code>Boolean</code> | <code>false</code> |  |

<a name="domainFromAddress"></a>

## domainFromAddress(address) ⇒ <code>json</code>
**Kind**: global function  
**Returns**: <code>json</code> - result  

| Param | Type | Description |
| --- | --- | --- |
| address | <code>string</code> | address of the domains |

